import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * This class overrides the movement of the main character (in this case the boy actor) and instead moves the other actors and the background back
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Man extends Actor
{
    final int RIGHT = 0;
    final int LEFT = 1;
    final int UP = 2;
    final int DOWN = 3;
    int actorX = 300;
    int actorY = 200;
    /**
     * Overrides the setLocation() method and instead moves the Other actors and the background back.
     * 
     */
    @Override public void setLocation(int x, int y)
    {
        int x2 = getX()-x;//gets where the man is trying to move
        int y2 = getY()-y;
        //actorX = x; 
        //actorY = y;
        List<Others> everyone = getWorld().getObjects(Others.class);
        for(int g = 0;g < everyone.size();g++)
            {
                Actor one = everyone.get(g);
                one.setLocation(one.getX()+x2,one.getY()+y2);//sets the location of the other actors back
            }
        ((Scroller) getWorld()).setThing(x2, y2);//moves the world back
    }
    /**
     * Overrides the move() method and instead moves the Other actors and the background back.
     */
    @Override public void move(int num)
    {
            List<Others> everyone = getWorld().getObjects(Others.class);
            if(everyone.size() > 0)
            {
                Actor one = everyone.get(0);
                int x = one.getX();
                int y = one.getY();
                int first = one.getRotation();
                one.setRotation(getRotation()-90);
                one.move(-num);
                one.setRotation(first);
                ((Scroller) getWorld()).setThing(one.getX()-x, one.getY()-y);//uses the first wombat to calculate how mucht the world should move
                //actorX += one.getX()-x;
                //actorY += one.getY()-y;
            }
            for(int g = 1;g < everyone.size();g++)//moves the other class
            {
                Actor one = everyone.get(g);
                int first = one.getRotation();
                one.setRotation(getRotation()-90);
                one.move(-num);
                one.setRotation(first);
            }
    }
    /**
     * From the direction, it figures out whether the world can be drawn this far back.
     * 
     */
    public boolean can(int direction)
    {
        int x = ((Scroller)getWorld()).x;
        int y = ((Scroller)getWorld()).y;
        if(direction == LEFT)
        {
            if(x < 0)
                return true;
            else
                return false;
        }
        else if(direction == RIGHT)
        {
            if(x > -400)
                return true;
            else
                return false;
        }
        else if(direction == UP)
        {
            if(y < 0)
                return true;
            else
                return false;
        }
        else if(direction == DOWN)
        {
            if(y > -600)
                return true;
            else
                return false;
        }
        else
            return false;
    }
    public boolean hitEdge()
    {
        int x = ((Scroller)getWorld()).x;
        int y = ((Scroller)getWorld()).y;
        int y_bounds = -600;
        int x_bounds = -400;
        if(x > 0 || y>0 || x < x_bounds || y < y_bounds)
            return true;
        else
            return false;
    }
}
